using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] l = Console.ReadLine().Split();
            int N = int.Parse(l[0]);
            int K = int.Parse(l[1]);
            int[,] matrica = new int[N, N];
            for (int i = 0; i < N; i++)
            {
                string[] u = Console.ReadLine().Split();
                for (int j = 0; j < N; j++)
                {
                    matrica[i, j] = int.Parse(u[j]);
                }
            }
            int resenje = 0;
            for (int sorta = 1; sorta <= K; sorta++)
            {
                int sirina_polja = 0;                
                bool da_li_smo_naski_neki = false;
                bool jel_ima_gap = false;                
                int x = 0;
                int y = 0;                
                int pomoc = 0;
                for (int i = 0; i < N; i++)
                {
                    for (int j = 0; j < N; j++)
                    {
                        if (pomoc == 0)
                        {
                            if (matrica[i, j] == sorta)
                            {
                                sirina_polja++;
                                da_li_smo_naski_neki = true;
                                x = i;
                                y = j;
                            }
                            if (da_li_smo_naski_neki == true && matrica[i, j] != sorta)
                            {
                                jel_ima_gap = true;
                            }
                            if (jel_ima_gap == true && matrica[i, j] == sorta)
                            {
                                goto nesto;
                            }
                        }
                        else
                        {
                            if (matrica[i, j] == sorta && (i != x + 1 || (j < y - sirina_polja + 1 || j > y)))
                            {
                                goto nesto;
                            }
                            else
                            {
                                int brojac = 0;
                                for (int pocetak = y - sirina_polja + 1; pocetak <= y; pocetak++)
                                {
                                    if (matrica[i, pocetak] == sorta)
                                    {
                                        brojac++;
                                    }
                                }
                                if (!(brojac == 0 || brojac == sirina_polja))
                                {
                                    goto nesto;
                                }
                            }                                                     
                            
                            
                        }


                                                                     

                    }
                    if (da_li_smo_naski_neki == true)
                    {
                        pomoc = 1;
                    }



                }

            resenje++;
            nesto:
                int q = 1;
            }
            
            Console.WriteLine(resenje);
            Console.ReadLine();






        }
    }
}